## ros-iron-rclpy 4.1.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(rclpy)

# Default to C++17
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 17)
  set(CMAKE_CXX_STANDARD_REQUIRED ON)
endif()
# Default to C11
if(NOT CMAKE_C_STANDARD)
  set(CMAKE_C_STANDARD 11)
endif()
if(CMAKE_COMPILER_IS_GNUCC OR CMAKE_C_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra)
endif()

# Figure out Python3 debug/release before anything else can find_package it
if(WIN32 AND CMAKE_BUILD_TYPE STREQUAL "Debug")
  find_package(python_cmake_module REQUIRED)
  find_package(PythonExtra REQUIRED)

  # Force FindPython3 to use the debug interpreter where ROS 2 expects it
  set(Python3_EXECUTABLE "${PYTHON_EXECUTABLE_DEBUG}")
endif()

find_package(ament_cmake REQUIRED)
find_package(ament_cmake_python REQUIRED)
find_package(lifecycle_msgs REQUIRED)
find_package(rcl REQUIRED)
find_package(rcl_action REQUIRED)
find_package(rcl_interfaces REQUIRED)
find_package(rcl_lifecycle REQUIRED)
find_package(rcl_logging_interface REQUIRED)
find_package(rcl_yaml_param_parser REQUIRED)
find_package(rcpputils REQUIRED)
find_package(rcutils REQUIRED)
find_package(rmw REQUIRED)
find_package(rmw_implementation_cmake REQUIRED)
find_package(rosidl_runtime_c REQUIRED)

# Find python before pybind11
find_package(Python3 REQUIRED COMPONENTS Interpreter Development)

find_package(pybind11_vendor REQUIRED)
find_package(pybind11 REQUIRED)

# enables using the Python extensions from the build space for testing
file(WRITE "${CMAKE_CURRENT_BINARY_DIR}/test_rclpy/__init__.py" "")

ament_python_install_package(${PROJECT_NAME})

# Only build the library if a C typesupport exists
get_rmw_typesupport(typesupport_impls "rmw_implementation" LANGUAGE "c")
if(typesupport_impls STREQUAL "")
  message(STATUS "Skipping rclpy because no C typesupport library was found.")
  return()
endif()

# Set the build location and install location for a CPython extension
function(configure_build_install_location _library_name)
  # Install into test_rclpy folder in build space for unit tests to import
  set_target_properties(${_library_name} PROPERTIES
    # Use generator expression to avoid prepending a build type specific directory on Windows
    LIBRARY_OUTPUT_DIRECTORY $<1:${CMAKE_CURRENT_BINARY_DIR}/test_rclpy>
    RUNTIME_OUTPUT_DIRECTORY $<1:${CMAKE_CURRENT_BINARY_DIR}/test_rclpy>)

  # Install library for actual use
  install(TARGETS ${_library_name}
    DESTINATION "${PYTHON_INSTALL_DIR}/${PROJECT_NAME}"
  )
endfunction()

# Split from main extension and converted to pybind11
pybind11_add_module(_rclpy_pybind11 SHARED
  src/rclpy/_rclpy_logging.cpp
  src/rclpy/_rclpy_pybind11.cpp
  src/rclpy/action_client.cpp
  src/rclpy/action_goal_handle.cpp
  src/rclpy/action_server.cpp
  src/rclpy/client.cpp
  src/rclpy/clock.cpp
  src/rclpy/context.cpp
  src/rclpy/destroyable.cpp
  src/rclpy/duration.cpp
  src/rclpy/clock_event.cpp
  src/rclpy/exceptions.cpp
  src/rclpy/graph.cpp
  src/rclpy/guard_condition.cpp
  src/rclpy/lifecycle.cpp
  src/rclpy/logging.cpp
  src/rclpy/names.cpp
  src/rclpy/node.cpp
  src/rclpy/publisher.cpp
  src/rclpy/qos.cpp
  src/rclpy/event_handle.cpp
  src/rclpy/serialization.cpp
  src/rclpy/service.cpp
  src/rclpy/service_info.cpp
  src/rclpy/service_introspection.cpp
  src/rclpy/signal_handler.cpp
  src/rclpy/subscription.cpp
  src/rclpy/time_point.cpp
  src/rclpy/timer.cpp
  src/rclpy/type_description_service.cpp
  src/rclpy/utils.cpp
  src/rclpy/wait_set.cpp
)

if(CMAKE_C_COMPILER_ID MATCHES "Clang" AND NOT APPLE)
  target_link_libraries(_rclpy_pybind11 PRIVATE atomic)
endif()

target_include_directories(_rclpy_pybind11 PRIVATE
  src/rclpy/
)
target_link_libraries(_rclpy_pybind11 PRIVATE
  lifecycle_msgs::lifecycle_msgs__rosidl_generator_c
  lifecycle_msgs::lifecycle_msgs__rosidl_typesupport_c
  rcl::rcl
  rcl_action::rcl_action
  ${rcl_interfaces_TARGETS}
  rcl_lifecycle::rcl_lifecycle
  rcl_logging_interface::rcl_logging_interface
  rcpputils::rcpputils
  rcutils::rcutils
  rosidl_runtime_c::rosidl_runtime_c
)
configure_build_install_location(_rclpy_pybind11)

if(NOT WIN32)
  ament_environment_hooks(
    "${ament_cmake_package_templates_ENVIRONMENT_HOOK_LIBRARY_PATH}"
  )
endif()

if(BUILD_TESTING)
  find_package(ament_lint_auto REQUIRED)
  # Give cppcheck hints about macro definitions coming from outside this package
  get_target_property(ament_cmake_cppcheck_ADDITIONAL_INCLUDE_DIRS rcutils::rcutils INTERFACE_INCLUDE_DIRECTORIES)
  list(APPEND AMENT_LINT_AUTO_EXCLUDE "ament_cmake_cppcheck")
  ament_lint_auto_find_test_dependencies()

  find_package(ament_cmake_cppcheck REQUIRED)
  ament_cppcheck()
  set_tests_properties(cppcheck PROPERTIES TIMEOUT 420)

  find_package(ament_cmake_pytest REQUIRED)
  find_package(rosidl_generator_py REQUIRED)
  find_package(ament_cmake_gtest REQUIRED)

  rosidl_generator_py_get_typesupports(_typesupport_impls)
  ament_index_get_prefix_path(ament_index_build_path SKIP_AMENT_PREFIX_PATH)
  # Get the first item (it will be the build space version of the build path).
  list(GET ament_index_build_path 0 ament_index_build_path)
  if(WIN32)
    # On Windows prevent CMake errors and prevent it being evaluated as a list.
    string(REPLACE "\\" "/" ament_index_build_path "${ament_index_build_path}")
  endif()

  ament_add_gtest(test_python_allocator
    test/test_python_allocator.cpp)
  target_include_directories(test_python_allocator PRIVATE src/rclpy)
  target_link_libraries(test_python_allocator pybind11::embed)

  if(NOT _typesupport_impls STREQUAL "")
    # Run each test in its own pytest invocation to isolate any global state in rclpy
    set(_rclpy_pytest_tests
      test/test_action_client.py
      test/test_action_graph.py
      test/test_action_server.py
      test/test_callback_group.py
      test/test_client.py
      test/test_clock.py
      test/test_context.py
      test/test_create_node.py
      test/test_create_while_spinning.py
      test/test_destruction.py
      test/test_executor.py
      test/test_expand_topic_name.py
      test/test_guard_condition.py
      test/test_init_shutdown.py
      test/test_logging.py
      test/test_logging_rosout.py
      test/test_logging_service.py
      test/test_messages.py
      test/test_node.py
      test/test_parameter.py
      test/test_parameter_client.py
      test/test_parameter_service.py
      test/test_publisher.py
      test/test_qos.py
      test/test_qos_event.py
      test/test_qos_overriding_options.py
      test/test_rate.py
      test/test_rosout_subscription.py
      test/test_serialization.py
      test/test_service_introspection.py
      test/test_subscription.py
      test/test_task.py
      test/test_time_source.py
      test/test_time.py
      test/test_timer.py
      test/test_topic_or_service_is_hidden.py
      test/test_topic_endpoint_info.py
      test/test_type_support.py
      test/test_type_hash.py
      test/test_utilities.py
      test/test_validate_full_topic_name.py
      test/test_validate_namespace.py
      test/test_validate_node_name.py
      test/test_validate_topic_name.py
      test/test_waitable.py
      test/test_wait_for_message.py
    )

    foreach(_test_path ${_rclpy_pytest_tests})
      get_filename_component(_test_name ${_test_path} NAME_WE)
      ament_add_pytest_test(${_test_name} ${_test_path}
        APPEND_ENV AMENT_PREFIX_PATH=${ament_index_build_path}
          PYTHONPATH=${CMAKE_CURRENT_BINARY_DIR}
        TIMEOUT 120
        WERROR ON
      )
    endforeach()
  endif()
endif()

ament_package()

=== debian/changelog ===
ros-iron-rclpy (4.1.3-1jammy) jammy; urgency=high

  * Fix get_type_description service bug and add a unit test (#1157 <https://github.com/ros2/rclpy/issues/1157>)
  * Avoid generating the exception when rcl_send_response times out. (#1151 <https://github.com/ros2/rclpy/issues/1151>)
  * get_type_description service (#1140 <https://github.com/ros2/rclpy/issues/1140>)
  * Contributors: Emerson Knapp, Tomoya Fujita

 -- Shane Loretz <sloretz@openrobotics.org>  Thu, 07 Sep 2023 16:00:00 -0000

ros-iron-rclpy (4.1.2-1jammy) jammy; urgency=high

  * Include type hash in topic endpoint info (#1134 <https://github.com/ros2/rclpy/issues/1134>)
  * Contributors: Hans-Joachim Krauch

 -- Shane Loretz <sloretz@openrobotics.org>  Thu, 13 Jul 2023 16:00:00 -0000

ros-iron-rclpy (4.1.1-1jammy) jammy; urgency=high

  * Fix type in Node init args (#1115 <https://github.com/ros2/rclpy/issues/1115>) (#1122 <https://github.com/ros2/rclpy/issues/1122>)
  * Contributors: mergify[bot]

 -- Shane Loretz <sloretz@openrobotics.org>  Wed, 10 May 2023 16:00:00 -0000

ros-iron-rclpy (4.1.0-1jammy) jammy; urgency=high

  * Logging service support (#1102 <https://github.com/ros2/rclpy/issues/1102>)
  * Use custom sourcedir for conf.py (#1109 <https://github.com/ros2/rclpy/issues/1109>)
  * ServerGoalHandle should be destroyed before removing. (#1113 <https://github.com/ros2/rclpy/issues/1113>)
  * Fix unnecessary list comprehension flake8 (#1112 <https://github.com/ros2/rclpy/issues/1112>)
  * Contributors: Barry Xu, Michael Carroll, Tomoya Fujita, Yadu

 -- Shane Loretz <sloretz@openrobotics.org>  Mon, 17 Apr 2023 16:00:00 -0000

ros-iron-rclpy (4.0.0-1jammy) jammy; urgency=high

  * Stub type hash value line in TopicEndpointInfo string (#1110 <https://github.com/ros2/rclpy/issues/1110>)
  * Support documentation generation using rosdoc2 (#1103 <https://github.com/ros2/rclpy/issues/1103>)
  * Fix Time and Duration raising exception when compared to another type (#1007 <https://github.com/ros2/rclpy/issues/1007>)
  * Make rcl_interfaces a build and exec dependency. (#1100 <https://github.com/ros2/rclpy/issues/1100>)
  * Solving Atomic undefined on OSX with clang (#1096 <https://github.com/ros2/rclpy/issues/1096>)
  * Implement matched event (#1083 <https://github.com/ros2/rclpy/issues/1083>)
  * Update service.py documentation (#1094 <https://github.com/ros2/rclpy/issues/1094>)
  * Allow space or empty strings when using ros2 param set (#1093 <https://github.com/ros2/rclpy/issues/1093>)
  * Hook up the incompatible type event inside of rclpy (#1058 <https://github.com/ros2/rclpy/issues/1058>)
  * Switch to using module instead of module_ (#1090 <https://github.com/ros2/rclpy/issues/1090>)
  * Add in subscription.get_publisher_count() (#1089 <https://github.com/ros2/rclpy/issues/1089>)
  * Contributors: Barry Xu, Chris Lalancette, Emerson Knapp, Erki Suurjaak, Felix Divo, GuiHome, Lucas Wendland, Yadu

 -- Shane Loretz <sloretz@openrobotics.org>  Tue, 11 Apr 2023 16:00:00 -0000

ros-iron-rclpy (3.10.0-1jammy) jammy; urgency=high

  * Service introspection (#988 <https://github.com/ros2/rclpy/issues/988>)
  * Contributors: Brian

 -- Shane Loretz <sloretz@openrobotics.org>  Tue, 28 Feb 2023 16:00:00 -0000

ros-iron-rclpy (3.9.0-1jammy) jammy; urgency=high

  * to create a sublogger while getting child of Logger (#1084 <https://github.com/ros2/rclpy/issues/1084>)
  * Fix #983 <https://github.com/ros2/rclpy/issues/983> by saving future and checking for + raising any exceptions (#1073 <https://github.com/ros2/rclpy/issues/1073>)
  * Contributors: Achille Verheye, Chen Lihui

 -- Shane Loretz <sloretz@openrobotics.org>  Thu, 23 Feb 2023 16:00:00 -0000

ros-iron-rclpy (3.8.0-1jammy) jammy; urgency=high

  * Force C++17 support on. (#1076 <https://github.com/ros2/rclpy/issues/1076>)
  * Use RCPPUTILS_SCOPE_EXIT to cleanup unparsed_indices_c. (#1075 <https://github.com/ros2/rclpy/issues/1075>)
  * Explicitly link atomic when building with Clang (#1065 <https://github.com/ros2/rclpy/issues/1065>)
  * Fix test_publisher linter for pydocstyle 6.2.2 (#1063 <https://github.com/ros2/rclpy/issues/1063>)
  * Add default preset qos profile (#1062 <https://github.com/ros2/rclpy/issues/1062>)
  * Add on_parameter_event method to the AsyncParameterClient. (#1061 <https://github.com/ros2/rclpy/issues/1061>)
  * Add documentation page for rclpy.clock (#1055 <https://github.com/ros2/rclpy/issues/1055>)
  * Rewrite test code without depending on parameter client (#1045 <https://github.com/ros2/rclpy/issues/1045>)
  * Add parallel callback test (#1044 <https://github.com/ros2/rclpy/issues/1044>)
  * decorator should not be callable. (#1050 <https://github.com/ros2/rclpy/issues/1050>)
  * typo fix. (#1049 <https://github.com/ros2/rclpy/issues/1049>)
  * Add in a warning for a depth of 0 with KEEP_LAST. (#1048 <https://github.com/ros2/rclpy/issues/1048>)
  * Add feature of wait for message (#953 <https://github.com/ros2/rclpy/issues/953>). (#960 <https://github.com/ros2/rclpy/issues/960>)
  * Document rclpy.time.Time class (#1040 <https://github.com/ros2/rclpy/issues/1040>)
  * Deal with ParameterUninitializedException for parameter service (#1033 <https://github.com/ros2/rclpy/issues/1033>)
  * Improve documentation in rclpy.utilities (#1038 <https://github.com/ros2/rclpy/issues/1038>)
  * Document rclpy.utilities.remove_ros_args (#1036 <https://github.com/ros2/rclpy/issues/1036>)
  * Fix incorrect comparsion on whether parameter type is NOT_SET (#1032 <https://github.com/ros2/rclpy/issues/1032>)
  * [rolling] Update maintainers (#1035 <https://github.com/ros2/rclpy/issues/1035>)
  * Contributors: Audrow Nash, Barry Xu, Chris Lalancette, Cristóbal Arroyo, Florian Vahl, Ivan Santiago Paunovic, Lei Liu, Sebastian Freitag, Shane Loretz, Tomoya Fujita

 -- Shane Loretz <sloretz@openrobotics.org>  Sun, 12 Feb 2023 16:00:00 -0000

ros-iron-rclpy (3.7.1-1jammy) jammy; urgency=high



=== debian/control ===
Source: ros-iron-rclpy
Section: misc
Priority: optional
Maintainer: Shane Loretz <sloretz@openrobotics.org>
Build-Depends: debhelper (>= 9.0.0), python3-pytest <!nocheck>, ros-iron-ament-cmake, ros-iron-ament-cmake-gtest <!nocheck>, ros-iron-ament-cmake-pytest <!nocheck>, ros-iron-ament-lint-auto <!nocheck>, ros-iron-ament-lint-common <!nocheck>, ros-iron-lifecycle-msgs, ros-iron-pybind11-vendor, ros-iron-python-cmake-module, ros-iron-rcl, ros-iron-rcl-action, ros-iron-rcl-interfaces, ros-iron-rcl-lifecycle, ros-iron-rcl-logging-interface, ros-iron-rcl-yaml-param-parser, ros-iron-rcpputils, ros-iron-rcutils, ros-iron-rmw, ros-iron-rmw-implementation, ros-iron-rmw-implementation-cmake, ros-iron-rosidl-generator-py <!nocheck>, ros-iron-rosidl-runtime-c, ros-iron-test-msgs <!nocheck>, ros-iron-unique-identifier-msgs, ros-iron-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-iron-rclpy
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-iron-action-msgs, ros-iron-ament-index-python, ros-iron-builtin-interfaces, ros-iron-lifecycle-msgs, ros-iron-rcl, ros-iron-rcl-action, ros-iron-rcl-interfaces, ros-iron-rcl-lifecycle, ros-iron-rcl-logging-interface, ros-iron-rcl-yaml-param-parser, ros-iron-rmw, ros-iron-rmw-implementation, ros-iron-rosgraph-msgs, ros-iron-rosidl-runtime-c, ros-iron-rpyutils, ros-iron-unique-identifier-msgs, ros-iron-ros-workspace
Description: Package containing the Python client.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/iron/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/iron" \
		-DAMENT_PREFIX_PATH="/opt/ros/iron" \
		-DCMAKE_PREFIX_PATH="/opt/ros/iron" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-iron-rclpy//opt/ros/iron/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_install
